<?php

# This program is distributed under the terms of the GNU General Public License.
# See the README & LICENSE files for more information.
# Copyright (C) 2001-2003  Kevin L. Papendick <kevinp@polarlava.com>


# This file SHOULD NOT be edited by the user.
# User configuration value should be place in the myclient_cfg.local.php file.

#############################
### Session Configuration ###
#############################
include('myclient_cfg.php');
if (file_exists('myclient_cfg.local.php')) {
	include('myclient_cfg.local.php');
}
include('myclient_sys.inc.php');

set_time_limit($set_time_limit);
session_name('MyClient');

if ($session_save_path) {
	session_save_path($session_save_path);
}
session_start();


##################
### Save Query ###
##################
if ($save_query) {
	$query_sent = stripslashes($query_sent);
	$save_filename = 'myclient' . $_SESSION['query_win_current'] . '.sql';
	$content_length = strlen($query_sent);

	header("Content-Type: application/force-download");
	header("Content-Disposition: attachment; filename=$save_filename");
	header("Content-Length: $content_length");
	header("Content-Transfer-Encoding: binary");

	print $query_sent;

	unset($save_query);
	exit;
}


############################
### Page Caching Control ###
############################
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");					// Date in the past
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");	// always modified
header("Cache-Control: no-store, no-cache, must-revalidate");  // HTTP/1.1
header("Cache-Control: post-check=0, pre-check=0", false);
header("Pragma: no-cache");												// HTTP/1.0

if (!$charset) {
	$charset = 'iso-8859-1';
}
header("Content-type: text/html; charset=$charset");


###################
### Page Header ###
###################
include($page_header);


#############################
### Load Query - Retrieve ###
#############################
if ($query_file && $query_file != 'none') {
	$orig_name = $HTTP_POST_FILES['query_file']['name'];
	$src_data = $HTTP_POST_FILES['query_file']['tmp_name'];
	$fd = fopen ($src_data, "r");
	$query_sent = fread ($fd, filesize ($src_data));
	fclose ($fd);

	### Flag SQL window not to run
	$new_query_loaded = 1;

} elseif ($query_file == 'none') {
	#Load button w/o filename pressed...
	$load_query = 1;
}


###########################
### Load Query - Prompt ###
###########################
if ($load_query) {
	print <<<LOAD_QUERY

		<form action="$PHP_SELF" enctype="multipart/form-data" method="post">
			<table border="0">
			 <tr>
			  <td>
				<input type="hidden" name="max_file_size" value="2500000">
				<font size="+1">File Name:</font>
			  </td>
			  <td>
				<input type="file" size="60" name="query_file">
			  </td>
			 </tr>
			 <tr>
			  <td>&nbsp;</td>
			 </tr>
			 <tr>
			  <td>&nbsp;</td>
			  <td>
			   <input type="submit" value="Load Query">
			   &nbsp;&nbsp;
			   <input type="reset" value="Reset">
			  </td>
			 </tr>
		</table>
		</form>
		$menu

LOAD_QUERY;

include($page_footer);
exit;
}


#############
### Login ###
#############
if ($login) {

	### Old Session Cleanup ###
	$age_time = time() - ($session_timeout * 3600);
	if ($dh = opendir($session_save_path)) {
		while (false !== ($file = readdir($dh))) {
			if ($file != "." && $file != ".." && preg_match('/sess_/', $file)) {
				$file_time = fileatime("$session_save_path/$file");
				if ($file_time <= $age_time) {
					unlink("$session_save_path/$file");
				}
			}
		}
		closedir($dh);
	}


	$_SESSION['db_user'] = $db_user;
	$_SESSION['db_pw'] = $db_pw;
	$_SESSION['db_name'] = $db_name;
	$_SESSION['db_host'] = $db_host;
	$_SESSION['db_port'] = $db_port;
	$_SESSION['valid'] = 0;

	if (!$_SESSION['db_port']) {
		$_SESSION['db_port'] = '3306';
	}
	$db_connect = @mysql_connect($_SESSION['db_host'] . ':' . $_SESSION['db_port'], $_SESSION['db_user'], $_SESSION['db_pw']);

	###########################
	### PHP & MySQL Version ###
	###########################
	$_SESSION['php_version'] = phpversion();
	$_SESSION['mysql_version'] = 'Unknown';
	$db_connect = @mysql_connect($_SESSION['db_host'] . ':' . $_SESSION['db_port'], $_SESSION['db_user'], $_SESSION['db_pw']);
	$query = "SELECT VERSION();";
	$result = @mysql_db_query($_SESSION['db_name'], $query, $db_connect);
	if ($result) {
		$_SESSION['valid'] = 1; //valid connection
		$v = mysql_fetch_row($result);
		$_SESSION['mysql_version'] = $v[0];
		unset($query);
	} else {
		$err_msg = "Login Authorization Failed!";
		$logout = 1;
		$_SESSION['valid'] = 0;
	}
	$_SESSION['query_win_current'] = 1;
	$_SESSION['query_win'] = array();
}


###############
### Log Out ###
###############
if ($logout) {
	session_destroy();
	unset($_SESSION['valid']);
	unset($login);
}

if ($reset) {
	unset($query);
}



##########################
### Display Login Form ###
##########################
if (!$_SESSION['valid']) {
	print <<<LOGIN_TOP
			<form method="post" action="$PHP_SELF">
				<table border="0" align="center" width="30%" cellspacing="5">
					<tr>
						<td bgcolor="$display_hdr_bg" colspan="2" align="center">
							<b>Database Login</b>
							<br>
						</td>
					</tr>
					<tr>
						<td>
							User:
						</td>
						<td>
LOGIN_TOP;

	if (isset($db_user_list)&& is_array($db_user_list)) {
		sort($db_user_list);
?>
							<select name="db_user">
<?php
	foreach ($db_user_list as $user) {

		//--- Active Selection?
		unset($selected);
		if ($user === $db_user_default) {
			$selected = 'selected';
		} else {
			$selected = '';
		}
?>
				         <option value="<?php echo $user; ?>" <?php echo "$selected"; ?>>
          				 <?php echo $user; ?>
        					</option>
<?php
		} //end foreach
?>
							</select>
<?php

	} else {
	print <<<LOGIN_USER
							<input type="text" size="20" name="db_user" value="$db_user_default">
LOGIN_USER;
	}

	print <<<LOGIN_MID
						</td>
					</tr>
					<tr>
						<td>
							Password:
						</td>
						<td>
							<input type="password" size="20" name="db_pw">
						</td>
					</tr>
					<tr>
						<td>
							Database:
						</td>
						<td>
LOGIN_MID;

	if (isset($db_name_list)&& is_array($db_name_list)) {
		sort($db_name_list);
?>
							<select name="db_name">
<?php
	foreach ($db_name_list as $db) {

		//--- Active Selection?
		unset($selected);
		if ($db === $db_name_default) {
			$selected = 'selected';
		} else {
			$selected = '';
		}
?>
				         <option value="<?php echo $db; ?>" <?php echo "$selected"; ?>>
          				 <?php echo $db; ?>
        					</option>
<?php
		} //end foreach
?>
							</select>
<?php

	} else {
		print <<<LOGIN_DB
							<input type="text" size="20" name="db_name" value="$db_name_default">
LOGIN_DB;
	}

	print <<<LOGIN_END

					 <td>
					</tr>
					<tr>
						<td>
							Host:
						</td>
						<td>
							<input type="text" size="20" name="db_host" value="$db_host_default">
						</td>
					</tr>
					<tr>
						<td>
							Port:
						</td>
						<td>
							<input type="text" size="20" name="db_port" value="$db_port_default">
						</td>
					</tr>
					<tr>
						<td colspan="2" align="center">
				        <input type="submit" name="login" value="Login">
				        &nbsp;<input type="reset">
						</td>
					</tr>
				</table>
			</form>

LOGIN_END;
	if ($err_msg) {
		print "<p align=\"center\">
					<font color=\"$display_error_color\">
						<b>ERROR: </b>
					</font>
					<b>$err_msg</b>";
		unset($err_msg);
	}
}

if (!$mode) { $mode = $mode_default; }

if ($_SESSION['valid'] && $docs == 1) {
	#View Documentation
	include($myc_docs);
}elseif ($_SESSION['valid'] && $mode == 0) {
	#SQL Interface
	include($myc_sql_client);
} elseif ($_SESSION['valid'] && $mode == 1) {
	#Table Dump Interface
	include($myc_table_dump);
}


###################
### Page Footer ###
###################
include($page_footer);
?>
